## ICUM 1.0################################################################
#Creado por Miguel Poyatos, Andres Martinez y Rafael Otal
#http://icum.wordpress.com
#Por favor mandar los bugs a miguelpoyatosmora@gmail.com
###########################################################################

import wx
import os
import sys
from ficheros import cargarFichero
from ficheros import escribirFichero
from sysUtils import msgbox 

def create(parent,software,carreras):
    return FramePrincipal(parent,software,carreras)

class FramePrincipal(wx.Frame):
    estado=0
    
    def _init_ctrls(self, prnt):
        # generated method, don't edit

        wx.Frame.__init__(self, id=wx.NewId(), name='FramePrincipal',
              parent=prnt, pos=wx.Point(164, 131), size=wx.Size(698, 450),
              style=wx.DEFAULT_FRAME_STYLE, title='Instalador Configurador Universitario para Molinux')
        self.SetClientSize(wx.Size(800, 500))

        self.PanelFondo = wx.Panel(id=wx.NewId(),
              name='PanelFondo', parent=self, pos=wx.Point(0, 0),
              size=wx.Size(800, 500), style=wx.TAB_TRAVERSAL)

        self.staticLine1 = wx.StaticLine(id=wx.NewId(),
              name='staticLine1', parent=self.PanelFondo, pos=wx.Point(10, 449),
              size=wx.Size(780, 2), style=0)
        
        self.BotonCancelar = wx.Button(id=wx.NewId(),
              label='Cancelar', name='BotonCancelar', parent=self.PanelFondo,
              pos=wx.Point(690, 460), size=wx.Size(100, 30), style=0)
        self.BotonCancelar.Bind(wx.EVT_BUTTON, self.OnBotonCancelarButton)
        
        self.BotonSiguiente = wx.Button(id=wx.NewId(),
              label='Acepto', name='BotonSiguiente',
              parent=self.PanelFondo, pos=wx.Point(580, 460), size=wx.Size(100,
              30), style=0)
        self.BotonSiguiente.Bind(wx.EVT_BUTTON, self.OnBotonSiguienteButton)

        self.BotonAnterior = wx.Button(id=wx.NewId(),
              label='< Anterior', name='BotonAnterior', parent=self.PanelFondo,
              pos=wx.Point(480, 460), size=wx.Size(100, 30), style=0)
        self.BotonAnterior.Bind(wx.EVT_BUTTON, self.OnBotonAnteriorButton)
        self.BotonAnterior.Show(0)

        self.PanelInfo = wx.Panel(id=wx.NewId(),
              name='PanelInfo', parent=self.PanelFondo, pos=wx.Point(10, 10),
              size=wx.Size(320,430), style=wx.TAB_TRAVERSAL)

        self.PanelLicencia = wx.Panel(id=wx.NewId(),
              name='PanelLicencia', parent=self.PanelFondo, pos=wx.Point(340,
              10), size=wx.Size(450, 430),
              style=wx.TRANSPARENT_WINDOW | wx.TAB_TRAVERSAL)

        self.staticBoxLicencia = wx.StaticBox(id=wx.NewId(),
              label='Licencia', name='staticBoxLicencia',
              parent=self.PanelLicencia, pos=wx.Point(10,5), size=wx.Size(435,
              420), style=0)

        self.textCtrlLicencia = wx.TextCtrl(id=wx.NewId(),
              name='textCtrl1', parent=self.PanelLicencia, pos=wx.Point(18, 25),
              size=wx.Size(420, 393), style=wx.TE_READONLY | wx.TE_MULTILINE,
              value='')

        cargarFichero("licencia",self.textCtrlLicencia)
        
        self.PanelSelecion = wx.Panel(id=wx.NewId(),
              name='PanelSelecion', parent=self.PanelFondo, pos=wx.Point(340,
              10), size=wx.Size(420, 430), style=wx.TAB_TRAVERSAL)




        self.textDescrip = wx.TextCtrl(id=wx.NewId(),
              name='textDescrip', parent=self.PanelSelecion, pos=wx.Point(0,
              370), size=wx.Size(420, 50), style=wx.TE_READONLY | wx.TE_MULTILINE
              , value='Seleccione su carrera y el software que desea instalar')
        
        
      


        #contenido de panel seleccion
        #se crean dinamicamente los componenetes necesarios para la aplicacion
        #en funcion de los datos del xml

        self.scrolledWindowCarreras = wx.ScrolledWindow(id=wx.NewId(),
              name='scrolledWindowCarreras1', parent=self.PanelSelecion, pos=wx.Point(0, 10),
              size=wx.Size(230, 350), style=wx.VSCROLL)
        self.Bind(wx.EVT_MOVE, self.enter)
        

        self.scrolledWindows=[]
        self.scrolledPanelesWindows=[]
        self.radioButton=[]
        i=0
        self.checkBox=[]
           
        while i < len(self.software):
            self.software[i]
            
            self.scrolledWindows.append(wx.ScrolledWindow(id=wx.NewId(),
              name=str(i), parent=self.PanelSelecion, pos=wx.Point(240, 10),
              size=wx.Size(200, 350), style=wx.VSCROLL))
            self.scrolledWindows[i].Show(0)

            
            self.radioButton.append(wx.RadioButton(id=wx.NewId(),
              label=self.carreras[i], name=str(i),
              parent=self.scrolledWindowCarreras, pos=wx.Point(24, 24+i*25),
              size=wx.Size(190, 20), style=0))
            self.radioButton[i].Bind(wx.EVT_RADIOBUTTON, self.OnSelCarrera)
                 
            j=0
            self.checkBox.append([])
            while j < len(self.software[i]):
           
                self.checkBox[i].append( wx.CheckBox(id=wx.NewId(), label=self.software[i][j].nombre,
                    name=str(j), parent=self.scrolledWindows[i], pos=wx.Point(24,24+j*25),
                    size=wx.Size(130, 20), style=0 ))
                self.checkBox[i][j].Bind(wx.EVT_MOTION, self.enter)     
                self.checkBox[i][j].Bind(wx.EVT_CHECKBOX, self.marcar)
                
                j = j + 1

            self.scrolledWindows[i].SetVirtualSize((130,44+j*25))
            self.scrolledWindows[i].SetScrollRate(1,1)
            
            i = i + 1
        self.scrolledWindowCarreras.SetVirtualSize((190,44+i*25))
        self.scrolledWindowCarreras.SetScrollRate(1,1)

        self.scrolledWindows[0].Show(1)
            
        self.PanelPreinsta = wx.Panel(id=wx.NewId(),
              name='PanelPreinsta', parent=self.PanelFondo, pos=wx.Point(340,
              10), size=wx.Size(450, 430), style=wx.TAB_TRAVERSAL)

        self.PanelInstalacion = wx.Panel(id=wx.NewId(),
              name='PanelInstalacion', parent=self.PanelFondo, pos=wx.Point(340,
              10), size=wx.Size(450, 430), style=wx.TAB_TRAVERSAL)
        
        self.PanelInstalacion.Show(0)
        self.PanelPreinsta.Show(0)
        self.PanelSelecion.Show(0)
        #self.PanelLicencia.Show(1)

        
        self.TextPreinsta = wx.TextCtrl(id=wx.NewId(),
              name='TextPreinsta', parent=self.PanelPreinsta, pos=wx.Point(0,
              0), size=wx.Size(450, 430),
              style=wx.TE_READONLY | wx.TE_MULTILINE, value='')
        self.TextPreinsta.SetBackgroundColour(wx.Colour(232, 232, 232))

        self.textInsta = wx.TextCtrl(id=wx.NewId(),
              name='textCtrl1', parent=self.PanelInstalacion, pos=wx.Point(0,
              0), size=wx.Size(450, 430), style=wx.TE_READONLY | wx.TE_MULTILINE
              , value='Gracias por utililizar ICUM')
        cargarFichero("gracias",self.textInsta)

        try:
            imageFile = 'pixmaps/panelinfo.jpg'
            imagen1 = wx.Image(imageFile, wx.BITMAP_TYPE_ANY).ConvertToBitmap()
            self.imagen01=wx.StaticBitmap(self.PanelInfo, -1, imagen1, (0 , 0), (imagen1.GetWidth(), imagen1.GetHeight()))
            self.imagenes=[]
            
            i=0
            while i<len(self.software):
                j=0
                self.imagenes.append([])
                while j<len(self.software[i]):
                    if self.software[i][j].imagen != "":
                        
                        imagen1 = wx.Image("imagenes/"+self.software[i][j].imagen, wx.BITMAP_TYPE_PNG).ConvertToBitmap()
                        self.imagenes[i].append(wx.StaticBitmap(self.PanelInfo, -1, imagen1, (0 , 0), (imagen1.GetWidth(), imagen1.GetHeight())))
                        self.imagenes[i][j].Show(0)
                    j=j+1
                i=i+1
            

                
                self.SetIcon(wx.Icon('pixmaps/icono.png', wx.BITMAP_TYPE_PNG))
            
        except IOError:
            print "error: El archivo que contiene la imagen no se encuentra"
        
        
        self.BotonSiguiente.SetFocus()
        
        self.Centre()
        
        self.estado=1        
    #Constructor de la clase FramePrincipal            
    def __init__(self, parent,software,carreras):
        #inicializacion de las estructuras de datos
        self.software=software
        self.carreras=carreras
        
        
        #inicializacion de la interfaz grafica
        self._init_ctrls(parent)
        
        
        
        
    #metodo para la visulizacion de los paneles de software al seleccionar
    #los radioButton de las carreras 
    def OnSelCarrera(self,event):
        
        i=0
        while i<len(self.scrolledWindows):
            self.scrolledWindows[i].Show(0)
            if i==int(event.GetEventObject().Name):
                #cuando encontramos el panel responsable,
                #mostramos su panel asociado
                self.scrolledWindows[i].Show(1)
            i=i+1
        
    #metodo ejecutado al presionar el boton siguente de la aplicacion
    #responsable del control de la aplicacion y los estados
    def OnBotonSiguienteButton(self, event):
        #estado final de la aplicacion
        #Sale del programa
        if self.estado==4: 
            
            exit()

        #estado de instalacion de la aplicacion
        #prepara y ejecuta la instalacion seleccionada
        if self.estado==3: 
            self.Show(False)
            self.estado = 4
            
            self.BotonCancelar.Label='Finalizar'
            
            #con anadidos comprobamos que no hemos anadido ya el software
            anadidos=[]

            #texto del archivo bash de instalacion
            texto="#!/bin/bash\n"
            texto+="xterm -T ICUM -e apt-get install "
            i=0
            while i<len(self.software):
                j=0
                while j<len(self.software[i]):
                    
                    esta=False
                    for uno in anadidos:
                        if self.software[i][j].nombre==uno:
                            esta=True
                        
                    
                    #comprobamos que esta por instalar y sin anadir
                    if (self.software[i][j].estado==1 and esta==False):
                        #anadimos a la lista de ya procesados
                        anadidos.append(self.software[i][j].nombre)
                        #anadimos el programa instalable al comando de istalacion 
                        texto+=" "+self.software[i][j].comando 
                        
                    
            
                    j=j+1
                i=i+1
            #-y --force-yes para que no pida confirmacion
            texto+=" -y --force-yes\n"

            
            #escribimos el bash
            escribirFichero("inst",texto)
            
            self.Show(0)
            self.Centre()
            
            #ejecutamos el bash            
            os.system("chmod 744 inst")
            os.system("sh ./inst")

            self.BotonAnterior.Show(0)
            self.BotonSiguiente.Show(0)
            self.BotonCancelar.SetFocus()
            
            self.PanelPreinsta.Show(0)
            self.PanelInstalacion.Show(1)
            self.Show(1)
        
        
        #estado de preinstalacion de la aplicacion
        #lista el software seleccionado para confirmacion del usuario
        if self.estado==2: 
            
            #con anadidos comprobamos que no hemos anadido ya el software
            anadidos=[]
            
            texto="Se instalara el siguiente software :\n\n"
            
            #con hapasado comprobamos algun software ha sido marcado
            self.haPasado=0
            i=0
            while i<len(self.checkBox):
                j=0
                while j<len(self.checkBox[i]):
                    
                    #marcamos cada saoftware que ha sido checheado en su checkBox
                    #y hapasado 
                    if self.checkBox[i][j].GetValue():
                        self.software[i][j].estado=1
                        self.haPasado=1

                    
                    esta=False
                    for uno in anadidos:
                        if self.software[i][j].nombre==uno:
                            esta=True
                        
                    #comprobamos que esta por listar y sin anadir
                    if (self.software[i][j].estado==1 and esta==False):
                        anadidos.append(self.software[i][j].nombre)
                        texto=texto + "Nombre : " + self.software[i][j].nombre + '\n'
                        texto=texto + "Homologo : " + self.software[i][j].homologo + '\n'
                        texto=texto + "Comando : " + self.software[i][j].comando + '\n\n'

                    
                    j=j+1
                i=i+1
            #continuamos solo si haPasado
            if (self.haPasado==1):
                self.PanelSelecion.Show(0)

                i=0
                while i<len(self.imagenes):
                    j=0
                    while j<len(self.imagenes[i]):
                        if self.imagenes[i][j] != None:
                            self.imagenes[i][j].Show(0)
                        j=j+1
                    i=i+1
            
                self.TextPreinsta.Clear()
                self.TextPreinsta.write(texto)
                self.BotonSiguiente.Label='Instalar'    
                self.PanelPreinsta.Show(1)
                self.estado = 3
            else:
                msgbox("No ha selecionado ningun software para instalar por favor seleccione uno.","ICUM")
        
        
        #estado de seleccion de la instalacion
        #muestra el panel de seleccion de la aplicacion
        if self.estado==1: 
            self.PanelLicencia.Show(0)
            self.PanelSelecion.Show(1)
            self.estado = 2
            self.BotonSiguiente.Label='Siguiente >'
            self.BotonAnterior.Show(1)
        
        event.Skip()
        
    #metodo ejecutado al presionar el boton anterior de la aplicacion
    #responsable del control de la aplicacion y los estados
    def OnBotonAnteriorButton(self, event):
        
        #estado de licencia de la instalacion
        #muestra el panel de licencia de la aplicacion
        if self.estado==2: 
            self.PanelSelecion.Show(0)
            self.PanelLicencia.Show(1)
            self.BotonAnterior.Show(0)
            self.BotonSiguiente.Label='Acepto'
            self.estado = 1

        #estado de seleccion de la instalacion
        #muestra el panel de seleccion de la aplicacion
        if self.estado==3: 
            self.PanelPreinsta.Show(0)
            self.PanelSelecion.Show(1)
            self.BotonSiguiente.Label='Siguiente >'
            self.estado = 2
            

        
        event.Skip()
        
    #metodo llamado cuando se selecciona o deselecciona un software
    #usado para marcar a la vez los software de distintas carreras
    def marcar(self,event):
        check=event.GetEventObject()
        if(check.GetValue()):
            i=0
            while i<len(self.software):
                j=0
                while j<len(self.software[i]):
                    if self.software[i][j].nombre==check.Label:
                        #activamos los checkBox que coincidan con el
                        #nombre de la aplic checkeada
                        self.checkBox[i][j].SetValue(True)
            
                    j=j+1
                i=i+1

        else:
            i=0
            while i<len(self.software):
                j=0
                while j<len(self.software[i]):
                    if self.software[i][j].nombre==check.Label:
                        #desactivamos los checkBox que coincidan con el
                        #nombre de la aplic checkeada
                        self.checkBox[i][j].SetValue(False) 
                        self.software[i][j].estado=0
            
                    j=j+1
                i=i+1
            
    #metodo encargado de informar de cada software sobre el 
    #que se pasa con el raton mediante textos y imagenes
    def enter(self,event):
        try:
            i1=int(event.GetEventObject().Parent.Name)
            j1=int(event.GetEventObject().Name)
            
            #mostramos texto de descripcion y homologo
            self.textDescrip.Value=self.software[i1][j1].descripcion + " - Homologo: "+self.software[i1][j1].homologo
            
            i=0
            while i<len(self.imagenes):
                j=0
                while j<len(self.imagenes[i]):
                    if self.imagenes[i][j] != None:
                        #ocultamos todas las imagenes de softs
                        self.imagenes[i][j].Show(0)
                    j=j+1
                i=i+1
            if self.imagenes[i1][j1] != None:
                #mostramos la imagen sobre la que esta el raton
                self.imagenes[i1][j1].Show(1)

                
        except AttributeError:
            event.Skip()
        except IndexError:
            event.Skip()

    #Boton cancelar de la aplicacion 
    #Sale del programa
    def OnBotonCancelarButton(self, event):
        
        event.Skip()
        exit()

    
